package poi.bugs;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.ClientAnchor;
import org.apache.poi.ss.usermodel.Comment;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Drawing;
import org.apache.poi.ss.usermodel.RichTextString;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;

public class BugSetCellComment
{
	/**	@param args
	 *	@throws Exception 
	 */
	public static void main(String[] args)
	throws Exception
	{
		System.out.println("Start.");

		String fileName					= "BugSetCellComment.xls";

		HSSFWorkbook workbook			= new HSSFWorkbook();
		Sheet sheet						= workbook.createSheet();
		Drawing drawing					= sheet.createDrawingPatriarch();
		CreationHelper creationHelper	= sheet.getWorkbook().getCreationHelper();
		int nbRow						= 100;
		System.out.println("nbRow    : " + nbRow);
		int nbColumn					= 20;
		System.out.println("nbColumn : " + nbColumn);
		System.out.println();
		for (int noRow = 0; noRow < nbRow; noRow++)
		{
			System.out.println("noRow    : " + noRow);
			Row row						= sheet.createRow(noRow);
			for (int noColumn = 0; noColumn < nbColumn; noColumn++)
			{
				Cell cell				= row.createCell(noColumn);
				cell.setCellValue(noRow + " / " + noColumn);
				ClientAnchor anchor	= creationHelper.createClientAnchor();
			    anchor.setCol1(cell.getColumnIndex());
			    anchor.setCol2(cell.getColumnIndex()+4);
			    anchor.setRow1(row.getRowNum());
			    anchor.setRow2(row.getRowNum()+3);

			    Comment comment		= drawing.createCellComment(anchor);
			    RichTextString str	= creationHelper.createRichTextString(noRow + " / " + noColumn);
			    comment.setString(str);
			    cell.setCellComment(comment);
			}
		}

		FileOutputStream fileOut;
		try
		{
			fileOut						= new FileOutputStream(fileName);
			workbook.write(fileOut);
			fileOut.flush();
			fileOut.close(); 
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}

		System.out.println("Stop.");
	}
}
